Codeforces - 358D - Alyona and Strings(dp)

D. Alyona and Strings
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

After returned from forest, Alyona started reading a book. She noticed stringss and t, lengths of which aren and m respectively. As usual, reading bored Alyona and she decided to pay her attention to stringss and t, which she considered very similar.

Alyona has her favourite positive integer k and because she is too small,k does not exceed 10. The girl wants now to choosek disjoint non-empty substrings of string s such that these strings appear as disjoint substrings of stringt and in the same order as they do in strings. She is also interested in that their length is maximum possible among all variants.

Formally, Alyona wants to find a sequence of k non-empty stringsp1, p2, p3, ..., pk satisfying following conditions:

  • s can be represented as concatenation a1p1a2p2...akpkak + 1, wherea1, a2, ..., ak + 1 is a sequence of arbitrary strings (some of them may be possibly empty);
  • t can be represented as concatenation b1p1b2p2...bkpkbk + 1, whereb1, b2, ..., bk + 1 is a sequence of arbitrary strings (some of them may be possibly empty);
  • sum of the lengths of strings in sequence is maximum possible.

Please help Alyona solve this complicated problem and find at least the sum of the lengths of the strings in a desired sequence.

A substring of a string is a subsequence of consecutive characters of the string.

Input

In the first line of the input three integers n,m, k (1 ≤ n, m ≤ 1000,1 ≤ k ≤ 10) are given — the length of the strings, the length of the string t and Alyona's favourite number respectively.

The second line of the input contains string s, consisting of lowercase English letters.

The third line of the input contains string t, consisting of lowercase English letters.

Output

In the only line print the only non-negative integer — the sum of the lengths of the strings in a desired sequence.

It is guaranteed, that at least one desired sequence exists.

Examples
Input
3 2 2
abc
ab
Output
2
Input
9 12 4
bbaaababb
abbbabbaaaba
Output
7
Note

The following image describes the answer for the second sample case:


题意:给出两个字符串s和t,给出一个数字k,求s与t被划分不超过k段的最长公共子序列。


一碰到dp就跪,不会做,借鉴了大神博客的思路。

dp[i][j][k][0]表示,当前的子串还可以继续衔接

dp[i][j][k][1]表示,当前的子串已完成,可做为一段


当s[i] = t[j]时,明显子串还可以继续衔接,还没有完,所以考虑dp[i-1][j-1][k-1][1](上一段已完成的), dp[i-1][j-1][k][0] (这一段未完成的)

然后就是计算已完成段dp[i][j][k][1],显而易见dp[i-1][j][kk][1], dp[i][j-1][kk][1]要考虑在内,本段已完成 dp[i][j][kk][0]也要考虑,还是有比前两项大的可能


#include <iostream>
#include <algorithm>
#include <cstdio>
#include <stdlib.h>
#include <cmath>
#include <cstring>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <functional>
#include <vector>
#include <fstream>
#include <iomanip>
#define INF 0x3f3f3f3f
using namespace std;

int dp[1005][1005][15][3];

int main()
{
  int n, m, k;
  while(cin >> n >> m >> k) {
    char s[1005], t[1005];
    scanf("%s%s", s + 1, t + 1);  //新get的技能
    memset(dp, 0, sizeof(dp));
    for(int i = 1; i <= n; i++) {
      for(int j = 1; j <= m; j++) {
        if(s[i] == t[j])
          for(int kk = 1; kk <= k; kk++)
            dp[i][j][kk][0] = max(dp[i-1][j-1][kk-1][1], dp[i-1][j-1][kk][0]) + 1;
        for(int kk = 1; kk <= k; kk++)
          dp[i][j][kk][1] = max(max(dp[i-1][j][kk][1], dp[i][j-1][kk][1]), dp[i][j][kk][0]);
      }
    }
    printf("%d\n", dp[n][m][k][1]);
  }
  return 0;
}




评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值